-- Daily Global Check
-- by Jadya
-- EU-Well of Eternity

local addonName, addonTable = ...

local lists = DailyGlobalCheck.ListFunctions

function DailyGlobalCheck:LoadPlugin(list, data)

 if not lists:isList(list) then
  return
 end

 if not lists:CheckVersion(list) then
  print("|cff00FF00Daily Global Check |r- plugin |cffFF0000not|r loaded "..list["Title"].." (needs to be updated)")
  return
 end

 --print("|cff00FF00Daily Global Check |r- plugin loaded: "..list["Title"])
 local svar = DailyGlobalCheck_PluginData[list["Title"]]
 local index = lists:Find(list["Title"])
 
 if not svar or svar.active == nil then
  lists:setActive(list, true)
 end

 DailyGlobalCheck:PushData(data, list["Overrides"] and list["Overrides"]["isquestcompleted"], list["Title"])

 if not index then
  table.insert(DailyGlobalCheck.Lists, list)
  -- refresh the list buttons if the mainframe was created already
  if DGC_Mainframe then
   DGC_Mainframe:RefreshListButtons()
  end
 else
  DailyGlobalCheck.Lists[index] = list
  DailyGlobalCheck:Refresh(DailyGlobalCheck.Lists[index])
 end
end

local function contains(t, s)
 local result = false
 for k,v in pairs(t) do
  if v == tonumber(s) then result = true end
 end
 return result
end

local cooldowntime = {}
-- called by plugins' QUEST_LOG_UPDATE until they're fully localized
function DailyGlobalCheck:LocalizeQuestNames(pname, plugin_var, data)
 local _, list = lists:Find(pname)
 if not plugin_var or not list then return end
 if not cooldowntime[pname] then cooldowntime[pname] = GetTime()-11 end

 local changed, allset = false, false
 if GetTime() > cooldowntime[pname] + 10 then
  cooldowntime[pname] = GetTime()
  local i, s
  allset = true
  for i = 1, GetNumQuestLogEntries() do
   s = GetQuestLink(i)
   if s ~= nil then
    s = string.match(s, "Hquest:(%d+)")
    local newstr = select(1,GetQuestLogTitle(i))
	for name,ids in pairs(data) do
	 if contains(ids, s) then
      plugin_var[name] = newstr
      for k,v in pairs(ids) do
	   local qData = DailyGlobalCheck:getQData(v)
	   if qData and qData[2] ~= newstr then
		 --print("|cff00FF00Daily Global Check - Quest found and localized |r("..list["Data"][v][2].." -> "..newstr..")")
         qData[2] = newstr
         changed = true
		end
       end
 	 else
 	  allset = false
     end
	end
   end
  end
 end
 if changed then DailyGlobalCheck:Refresh(plugin) end
 return allset
end

function DailyGlobalCheck:SetPluginData()
 --
end

function DailyGlobalCheck:SetPluginOrderTitle()
 --
end